ArrayList<Bullet> bullets=new ArrayList<Bullet>();
boolean[] keys=new boolean[256];
color[] tmColors={color(20, 200, 20), color(20, 20, 200), color(200, 20, 20), color(100), color(200, 200, 20), color(20, 200, 200), color(200, 20, 200), color(200)};
ArrayList<Tank> tanks=new ArrayList<Tank>();
ArrayList<Tank>[] teams = new ArrayList[8];
int[] tKills=new int[8];
int s=3000;
int scoreT;
int scoreK;
Tank player;

void setup() {
  //size(500, 500);
  fullScreen();
  for (int i=0; i<8; i++)teams[i]=new ArrayList<Tank>();
  for (int i=0; i<25; i++) {
    Tank t=new Tank(random(s), random(s), i%8);
    tanks.add(t);
    teams[i%8].add(t);
  }
  int r=(int)random(tanks.size());
  tanks.get(r).pc=true;
  player=tanks.get(r);
  strokeWeight(5);
  textAlign(CENTER, CENTER);
  textSize(100);
}


void draw() {
  if (player.hp<=0&&teams[player.team].size()>0) {
    player=teams[player.team].get(0);
  }
  if (millis()%1000<=10) {
    Tank t=new Tank(random(s), random(s), (int)random(8));
    tanks.add(t);
    teams[t.team].add(t);
  }
  background(100, 150, 50);
  pushMatrix();
  if (tanks.size()>0)translate(width/2-player.pos.x, height/2-player.pos.y);
  for (int i=0; i<s/100; i++) {
    for (int j=0; j<s/100; j++) {
      fill(0, 0);
      stroke(200, 150, 60);
      rect(i*100, j*100, 100, 100);
    }
  }
  stroke(0);
  for (int i=0; i<bullets.size(); i++) {
    if (i<0)continue;
    Bullet b=bullets.get(i);
    b.update();
    if ((b.pos.x>s||b.pos.x<0)||(b.pos.y>s||b.pos.y<0)) {
      bullets.remove(b);
      i--;
      continue;
    }
    for (int j=0; j<tanks.size(); j++) {
      Tank t=tanks.get(j);
      if (dist(b.pos.x, b.pos.y, t.pos.x, t.pos.y)<25&&b.owner!=t&&t.team!=b.owner.team) {
        t.hp-=b.dmg;
        if (t.hp<=0) {
          teams[t.team].remove(t);
          tanks.remove(t);

          j--;
          b.owner.kills++;
          tKills[b.owner.team]++;
          if(b.owner==player)scoreK++;
        }
        bullets.remove(b);
        i--;
        continue;
      }
    }
  }  
  for (int i=0; i<tanks.size(); i++) {
    Tank t=tanks.get(i);
    t.update();
  }
  popMatrix();
  fill(0);
  textSize(50);
  textAlign(LEFT, TOP);
  scoreT=(int)(millis()/1000);
  text("Time: "+scoreT, 50, 50);
  for (int i=0; i<8; i++) {
    fill(tmColors[i]);
    textAlign(LEFT, TOP);
    text(teams[i].size(), 50, i*50+150);
    textAlign(RIGHT, TOP);
    text(tKills[i], width-50, i*50+150);
  }
  fill(0);
  textAlign(RIGHT, TOP);
  text("Kills: "+scoreK, width-50, 50);
}

void keyPressed() {
  if (key<256)keys[key]=true;
  if (keyCode==UP)keys['w']=true;
  else if (keyCode==LEFT)keys['a']=true;
  else if (keyCode==DOWN)keys['s']=true;
  else if (keyCode==RIGHT)keys['d']=true;
}

void keyReleased() {
  if (key<256)keys[key]=false;
  if (keyCode==UP)keys['w']=false;
  else if (keyCode==LEFT)keys['a']=false;
  else if (keyCode==DOWN)keys['s']=false;
  else if (keyCode==RIGHT)keys['d']=false;
}
